.Const

.Data?

szBuffer		Byte	32 Dup (?)
hLib			DWord	?


.Data

lCount1			LONG	0
lCount2			LONG	0
uTimer1			ULONG	0
uTimer2			ULONG	0

.Code

TestMasmProcedure Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	.If uMsg == WM_CREATE
		Invoke LoadLibrary, TextAddr("ECTimer.dll")
		Mov hLib, Eax
		Return TRUE
	.ElseIf uMsg == WM_COMMAND
		LoWord wParam
		.If Ax == IDC_TESTMASM_BUTTON1
			HiWord wParam
			.If Ax == BN_CLICKED
				.If uTimer1 || uTimer2
					Invoke StopTimers
				.Else
					Invoke GetProcAddress, hLib, TextAddr("BeginTimer")
					Push Eax
					Push Offset TimerProcedure
					Push 10
					Call Eax
					Mov uTimer1, Eax
					Pop Eax
					Push Offset TimerProcedure
					Push 100
					Call Eax
					Mov uTimer2, Eax
					Invoke SetButtonText, TextAddr("Stop timer")
				.EndIf
				Return TRUE
			.EndIf
		.EndIf
	.ElseIf uMsg == WM_CLOSE
		Invoke FreeLibrary, hLib
		Invoke IsModal, hWnd
		.If Eax
			Invoke EndModal, hWnd, IDCANCEL
			Return TRUE
		.EndIf
	.EndIf
	Return FALSE
TestMasmProcedure EndP

SetButtonText Proc Private lpszText:LPSTR
	Invoke GetWindowItem, App.Main, IDC_TESTMASM_BUTTON1
	Invoke SetWindowText, Eax, lpszText
	Ret
SetButtonText EndP

StopTimers Proc Private
	Invoke GetProcAddress, hLib, TextAddr("EndTimer")
	.If uTimer1
		Push Eax
		Push uTimer1
		Call Eax
		Mov lCount1, 0
		Mov uTimer1, 0
		Pop Eax
	.EndIf
	.If uTimer2
		Push uTimer2
		Call Eax
		Mov lCount2, 0
		Mov uTimer2, 0
	.EndIf
	Invoke SetButtonText, TextAddr("Start timer")
	Ret
StopTimers EndP

TimerProcedure Proc Private uID:ULONG
	Mov Eax, uID
	Cmp Eax, uTimer1
	Jne @F
	Invoke String, lCount1, Addr szBuffer, ecDecimal
	Invoke GetWindowItem, App.Main, IDC_TESTMASM_STATIC1
	Inc lCount1
	Jmp L2
@@:	Invoke String, lCount2, Addr szBuffer, ecDecimal
	Invoke GetWindowItem, App.Main, IDC_TESTMASM_STATIC2
	Inc lCount2
L2:	Invoke SetWindowText, Eax, Addr szBuffer
	Ret
TimerProcedure EndP
